package  
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Vector3D;
	import flash.text.TextField;

	public class Game extends MovieClip
	{
		public static var mouse 		:Vector3D = new Vector3D(100, 100);
		public static var width 		:Number = 0;
		public static var height 		:Number = 0;
		public static var showForces 	:Boolean = false;
		
		public var boids :Vector.<Boid> = new Vector.<Boid>;
		public var forces :Sprite;
		
		public function Game() {
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e :Event) :void {
			var i :int, boid :Boid;
			
			Game.width = stage.stageWidth;
			Game.height = stage.stageHeight;
			
			for (i = 0; i < 20; i++) {
				boid = new Boid(Game.width / 2, Game.height / 2, 20 +  Math.random() * 20);
				boid.reset();
				
				addChild(boid);
				boids.push(boid);
			}
			
			forces = new Sprite();
			addChild(forces);
			
			stage.addEventListener(MouseEvent.CLICK, function(e: Event) :void {
				showForces = !showForces;
			});
		}
		
		public function update():void {
			var i :int;
			
			forces.graphics.clear();
			
			for (i = 0; i < boids.length; i++) { 
				boids[i].update();
				drawForces(boids[i]);
			}
		}
		
		private function drawForces(boid :Boid) :void {
			var desired  :Vector3D = boid.desired.clone();
			var velocity :Vector3D = boid.velocity.clone();
			var steering :Vector3D = boid.steering.clone();
			
			velocity.normalize();
			desired.normalize();
			steering.normalize();
			
			// Force vectors
			if(showForces) {
				drawForceVector(boid, velocity, 0x00FF00);		
				drawForceVector(boid, desired, 0x454545);
				drawForceVector(boid, steering, 0x0000FF);
			}
		}
		
		private function drawForceVector(boid :Boid, force :Vector3D, color :uint, scale :Number = 100) :void {
			forces.graphics.moveTo(boid.x, boid.y);
			forces.graphics.lineStyle(2, color);
			forces.graphics.lineTo(boid.x + force.x * scale, boid.y + force.y * scale);
		}
	}
}